import base64
from cryptography.hazmat.backends import default_backend
from cryptography.hazmat.primitives import hashes
from cryptography.hazmat.primitives.kdf.pbkdf2 import PBKDF2HMAC
from cryptography.fernet import Fernet
import os

# purpose: class to encode the message or data or decode the encoded data
class init():

    def __init__(self, password):
        self.password = password

    # to  generate a key for data encode and decode
    # key would be 16 bytes
    def getEnKey(self):
        password = self.password.encode()  # convert the data to byte data type
        salt = b'Living Beings Are Boundless; I Vow to Save Them All.'  # fixed the salt
        #salt = os.urandom(16) # or you can use the random generation
        kdf = PBKDF2HMAC(
            algorithm=hashes.SHA256(),
            length=32, #for Fernet security policy, it should be 32 bytes
            salt=salt,
            iterations=100000,
            backend=default_backend()
        )
        key = base64.urlsafe_b64encode(kdf.derive(password))  # Can only use kdf once
        return(key)
    
    # data encode:
    # srcKey: password or keys
    # srcData: encoded source
    def dataEncode(self, srcData):
        enKey = self.getEnKey()
        f = Fernet(enKey) # Fernet guarantees that a message encrypted using it cannot be manipulated or read without the key.
        enData = f.encrypt(srcData.encode())  # encoding
        return(enData.decode())

    # data decode:
    # srcKey: password or keys
    # encData: decoded source
    def dataDecode(self, encData):
        enKey = self.getEnKey()
        f = Fernet(enKey)
        #deData = f.decrypt(encData.encode())  # Decrypt the bytes. The returning object is of type bytes
        deData = f.decrypt(encData)  # Decrypt the bytes. The returning object is of type bytes
        return(deData.decode())